<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 7: Input and Output</title>
<link href="sx9f.html" rev=precedes>
<link href="sx10a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 7: Input and Output</H1>

<p>page 151
</p><p>By ``Input and output facilities are
not part of the C language itself,''
we
mean that things like <TT>printf</TT> are just 
function calls like any other.
C has
no built-in input or output statements.
For our purposes,
the implications of this
fact--that I/O is not built in--is
mainly that the compiler may not do as much checking
as we might like it to.
If we accidentally write
<pre>	double d = 1.23;
	printf("%d\n", d);
</pre>the compiler says,
``Hmm, a function named <TT>printf</TT>
is being called with a string and a <TT>double</TT>.
Okay by me.''
The compiler does not
(and, in general, could not even if it wanted to)
notice that the <TT>%d</TT> format requires an <TT>int</TT>.
</p><p>Although the title of this chapter is ``Input and Output,''
it appears that we'll also be meeting
a few other routines from the standard library.
</p><p>If you start to do any serious programming on a particular system,
you'll undoubtedly discover that it has a number of more 
specialized input/output
(and other system-related) routines available,
which promise better performance or nicer functionality
than 
the pedestrian routines of C's standard library.
You should resist the temptation to use these nonstandard routines.
Because the standard library routines are defined precisely and
``exist in compatible form on any system where C exists,''
there are some real advantages to using them.
(On the other hand,
when you need to do something
which C's standard library routines don't provide,
you'll generally turn
to your machine's system-specific routines right away,
as they may be your only choice.
One common example is when
you'd like to read one character immediately,
without waiting for the RETURN key.
How you do that depends on what system you're using;
it is not defined by C.)
</p><p><a href="sx10a.html" rel=subdocument>section 7.1: Standard Input and Output</a></p>
<p><a href="sx10b.html" rel=subdocument>section 7.2: Formatted Output--Printf</a></p>
<p><a href="sx10c.html" rel=subdocument>section 7.3: Variable-length Argument Lists</a></p>
<p><a href="sx10d.html" rel=subdocument>section 7.4: Formatted Input--Scanf</a></p>
<p><a href="sx10e.html" rel=subdocument>section 7.5: File Access</a></p>
<p><a href="sx10f.html" rel=subdocument>section 7.6: Error Handling--Stderr and Exit</a></p>
<p><a href="sx10g.html" rel=subdocument>section 7.7: Line Input and Output</a></p>
<p><a href="sx10h.html" rel=subdocument>section 7.8.1: String Operations</a></p>
<p><a href="sx10i.html" rel=subdocument>section 7.8.2: Character Class Testing and Conversion</a></p>
<p><a href="sx10j.html" rel=subdocument>section 7.8.3: Ungetc</a></p>
<p><a href="sx10k.html" rel=subdocument>section 7.8.4: Command Execution</a></p>
<p><a href="sx10l.html" rel=subdocument>section 7.8.5: Storage Management</a></p>
<p><a href="sx10m.html" rel=subdocument>section 7.8.6: Mathematical Functions</a></p>
<p><a href="sx10n.html" rel=subdocument>section 7.8.7: Random Number Generation</a></p>
<hr>
<p>
Read sequentially:
<a href="sx9f.html" rev=precedes>prev</a>
<a href="sx10a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
